///////////////////////////////////////////////
// AutoDcReg Hedder file
//////////////////////////////////////////////
// Version
#define	VERSION "--- AutoDcReg V1.00 ---"

// Main Loop State Define
#define	ST_POWER_UP			10
#define	ST_STANBY			20
#define	ST_START_UP			30
#define	ST_OUTPUT			40
#define	ST_BAT_WARNING		50
#define	ST_BAT_LOW			60
#define	ST_BREAK_DOWN		70
#define	ST_BAT_LONGEVITY	80

// Timers DEFINE
#define	MSEC 		(120l)
#define	SEC 		(1078)
#define	TM_SLEEP	(64l)

#define	TM_ZERO		(int)(0)
#define	TM_120ms	(int)(120l/MSEC)
#define	TM_240ms	(int)(240l/MSEC)
#define	TM_480ms	(int)(480l/MSEC)
#define	TM_960ms	(int)(960l/MSEC)
#define	TM_1s		(int)(1000l/MSEC)

#define	TM_INFINITY	(int)(-1)
#define	TM_TIMEOUT		1
#define	TM_NOT_TIMEOUT	0

// LED of Power Up State
#define LED_POWER_UP_STATE 		LED_BLINK,TM_960ms,TM_960ms,TM_INFINITY
// LED of Stanby State
#define LED_STANBY_STATE 		LED_OFF,TM_ZERO,TM_ZERO,TM_INFINITY
// LED of StartUp State
#define LED_START_UP			LED_BLINK,TM_240ms,TM_240ms,TM_INFINITY
// LED of OutPut State
#define LED_OUTPUT_STATE		LED_ON,TM_INFINITY,TM_INFINITY,TM_INFINITY
// LED of Battery Warning State
#define LED_BAT_WARNING			LED_BLINK,TM_480ms,TM_480ms,TM_INFINITY
// LED of Battery Low State
#define LED_BAT_LOW_STATE		LED_BLINK,TM_120ms,TM_960ms,TM_INFINITY
// LED of Break Down State
#define LED_BREAK_DOWN_STATE 	LED_BLINK,TM_960ms,TM_120ms,TM_INFINITY

// LED of Bat Longevity State
#define LED_BAT_LONGEVITY		0 // using Delay1KTCYx(),follow as
#define DLY_LED_ON_BAT_LONGEVITY_TIME 100	// on time 50ms
#define DLY_LED_OFF_BAT_LONGEVITY_TIME 100	// off time 50ms



// Sleep Timer 
#define	SL_STANBY		16 // Sleep Time in case of Stanby (16*64ms = 1024ms)
#define	SL_OTHERS		1 // Sleep Time in case of Others (64)
#define	SL_1S	        ((1000l/(MSEC))+1l) // 55ms is adCnvLipple() time
#define	SL_10S	        ((10000l/(SEC))+1l) // 55ms is adCnvLipple() time


// VL Detect ,Output Led Time
#define	VL_LED_TIME		(5000l/100l)	// 5sec
// Lipple@Continuous Detection Timer
#define	TM_LIPPLE_ON	(char)(10000l/SEC)
#define	TM_LIPPLE_OFF	(char)(3000l/SEC)

// Battery Capacity 25%@Continuous Detection Timer
#define	TM_BAT_V25_ON	(char)(30000l/SEC)
#define	TM_BAT_V25_OFF	(char)(10000l/SEC)

// Battery Capacity 50%@Continuous Detection Timer
#define	TM_BAT_V50_ON	(char)(30000l/SEC)
#define	TM_BAT_V50_OFF	(char)(30000l/SEC)



//LED On/Off/Blink DEFINE
#define	LED_ON		1
#define	LED_OFF		0
#define	LED_BLINK	2

// Relay On/Off
#define	RY_ON		1
#define	RY_OFF		0

// A/D Refarence
#define	MAX_AD		1023.0
#define	MIN_AD		0.0
#define	AD_RANGE	5.0


// default threshhold value
#define AD_CH_BATTERY 	0
#define	AD_CH_LIPPLE	1

// A/D Average Buffer
#define	AD_BUF_SIZE	10

// Lipple Status
#define	LIPPLE_OFF			0
#define	LIPPLE_ON			1
#define	LIPPLE_INVALID		2

// BATTRY Capacity 25% Status
#define	BAT_V25_UNDER		0
#define	BAT_V25_OVER		1
#define	BAT_V25_INVALID		2

// BATTRY Capacity 50% Status
#define	BAT_V50_UNDER		0
#define	BAT_V50_OVER		1
#define	BAT_V50_INVALID		2

// Non Value For Display 
#define	NON_VALUE	(int)(-30000)

///////////////////////////////////////////////
//	Global Type Def
//////////////////////////////////////////////
//Battery TheshHold
typedef struct {
	int	Vbd;
	int	VbdTh;
	int	Vc;
	int	V100;
	int	V75;
	int	V50;
	int	V25;
	int	LvTh;
	int	Vl;
} T_BAT_TH_V;


typedef  rom char*  T_ROM ;

