///////////////////////////////////////////////////////////////
//
//	Eeprom Module
//
///////////////////////////////////////////////////////////////
#include	<p18f1320.h>
#include	<stdio.h>
#include	<reset.h>
#include	<string.h>
#include	<delays.h>
#include	"AutoDcReg.h"
#include	"Prototype.h"

////////////////////////////////////////////////////////////////
//	EEPROM Byte Write
//	<in> adr	:Eeprom address
//	     data	:write byte data
///////////////////////////////////////////////////////////////
void	EepromByteWr(int adr,unsigned char data)
{
	EEDATA = data;
	EEADR = adr;
	EECON1bits.EEPGD = 0;
	EECON1bits.CFGS = 0;
	EECON1bits.WREN = 1;
	EECON2 = 0x55;
	EECON2 = 0xaa;
	EECON1bits.WR = 1;
	while(EECON1bits.WR != 0);
	EECON1bits.WREN = 0;
}
///////////////////////////////////////////////////////////////
//	EEPROM Block Write
//	<in> adr	:Eeprom address
//	     data	:Write data buffer
//		 len	:Length
///////////////////////////////////////////////////////////////
void	EepromBlockWr(int adr,unsigned char *data,char len)
{
char i;
unsigned char wr;
	for(i=0;i<len;i++){
		wr = *data;
		EepromByteWr(adr+i,*data);
		data ++;
	}
}

////////////////////////////////////////////////////////////////
//	EEPROM Byte Read
//	<in> adr	:Eeprom address
//  <out>		:Read Byte data
///////////////////////////////////////////////////////////////
unsigned char	EepromByteRd(int adr)
{
	EEADR = adr;
	EECON1bits.EEPGD = 0;
	EECON1bits.CFGS = 0;
	EECON1bits.RD = 1;
	while(EECON1bits.RD != 0);
	return(EEDATA);
}
////////////////////////////////////////////////////////////////
//	EEPROM Block Read
//	<in> adr	:Eeprom address
//  	@buffer	:save adr
//  @@@@@len	:length
////////////////////////////////////////////////////////////////
void	EepromBlockRd(int adr,unsigned char *buffer,char len)
{
char i;
	for(i=0;i<len;i++){
		buffer[i] = EepromByteRd(adr+i);
	}
}
