//////////////////////////////////////////////////////////////////////////////
//	function prototype
//////////////////////////////////////////////////////////////////////////////
// interrupt handler.(interrupt.c)
void	InitInterrupt(void);			// interrupt Initialize
void 	InterruptHandlerHigh (void);	// interrupt handler
int		intGetBatteryAd(void);				// Batery Ad Get
int		intGetLippleAd(void);				// Lipple Ad Get
int		intGetLippleAd(void);				// max lipple Ad Get
int		intGetMinLippleAd(void);			// min lipple Ad Get
int		intGetLippleVppAd(void);			// lipple peak to peak Ad Get
void	intClrLipple(void);					// lipple peak to peak Ad clear
char 	int100msChk(void);					// 100ms refarence timer check
void	intPutsUart(char *str);			// Uart Send String	for debug
char	intChkUart(void);					// Uart Idle Check for debug

#define	intEnable()		(INTCONbits.GIE	= 1)	// interupt enable
#define	intDisable()	(INTCONbits.GIE	= 0)	// interupt disable


// I/O Driver. (io.c)
void	ioInitPortRa(void);		// port RA Initialize
void	ioInitPortRb(void);		// port RB Initialize
void	ioFlash(void);			// I/O Flash


// A/D Input Driver
void	adInit(void);				// A/D initialize
int		adGetBattery(void);			// Battery A/D Get
int 	adCnvBattery1(void); 		// Battery A/D 1 Get  
int		adGetLipple(void);			// Lipple A/D Get
char	adGetLippleStatus(int ad,int th_lipple_ad);// lipple status get
char	adGetBatV25Status(int ad,int th_v25);// Battery Capacity 25% Check
char	adGetBatV50Status(int ad,int th_v50);// Battery Capacity 50% Check
void	adCnvBattery(void);				// A/D Conversion Battry Voltage   
void	adCnvLipple(void);				// A/D Conversion Battry Lipple

void	adLippleStatusClr(void);		// Lipple Status initialze
void	adBatV25StatusClr(void);		// Bat V25 Status initialze
void	adBatV50StatusClr(void);		// Bat V50 Status initialze




// Initialize function
void 	tmInit(void);				// Timer Module Initialize
char 	tm100msChk(void);			// 100ms Interval Check
char 	tm1sChk(void);				// 1s Interval Check
void 	tmSetTimer(int time);		// General Timer Set
char 	tmGetTimeOut(void);			// General Timer Check

// EEPROM function
void			EepromByteWr(int adr,unsigned char data);	// Eeprom Byte Write
void			EepromBlockWr(int adr,unsigned char *data,char len);	// Eeprom Byte Write
unsigned char	EepromByteRd(int adr);						// Eeprom Byte Read
void			EepromBlockRd(int adr,unsigned char *data,char len);						// Eeprom Byte Read

// UART(for debug) function
void			uartInit(void);
void			uartPutStrValue(rom char *a,int b);
//#define uartPutStrValue(a,b)    uartPutStrValue((rom char *)a,b)

// LED function
void			LedOnOff(int on);											// LED i/o ON/OFF Driver
void			LedSet(char methood,char on_time,char off_time,char count);	// LED ON/OFF/BLINK Set
void			LedControl(void);														// LED ON/OFF/BLINK controll
void			LLedVoltageOutput(int v);

int				AdToV(int ad);
int				AdToV5(int ad);
void 			BSort(int num[],char n);

// subroutine
void			IToAsc(char *asc,int value,int n);
void			WdtClr(void);								// WDT Clear

// Caribration Module
void calExec(T_BAT_TH_V *pBatThV);
void calDataRead(T_BAT_TH_V *pBatThV);



