/////////////////////////////////////////
//
// UART Module
//
//////////////////////////////////////////
#include	<p18f1320.h>
#include	<stdio.h>
#include	<reset.h>
#include	<string.h>
#include	<delays.h>

#include	"AutoDcReg.h"
#include	"Prototype.h"
#include	"Io.h"

#pragma udata RAM_TOP
char m_TxBuf[0x30];	// uart Transmit buffer
void 			uartInit(void)
{
}
void	uartChar(unsigned c)
{
char i;
	ClrWdt();
	PORT_SERIAL = 1;	// Start Bit
	Delay10TCYx(18);
	Delay1TCY();
	Delay1TCY();
	Delay1TCY();
	Delay1TCY();
	Delay1TCY();
	Delay1TCY();
	Delay1TCY();




	for(i=0;i<8;i++){
		if ((c & 0x01) == 0){
			PORT_SERIAL = 1;
		}else{
			PORT_SERIAL = 0;
		}
		c >>= 1;
		Delay1TCY();
		Delay1TCY();
		Delay1TCY();
		Delay10TCYx(17);
	}
	PORT_SERIAL = 0;	// Stop Bit
	Delay10TCYx(19);

}
void	uartPuts(char *p_buf)
{
char	i;
	for(i=0;i<sizeof(m_TxBuf);i++){
		if (*p_buf == 0)break;
		uartChar(*p_buf);
		p_buf ++;
	}
}

void	uartPutStrValue(rom char *str,int val)
{
	if (PORT_DSW3_RS == DSW3_RS_DEBUG){
		strcpypgm2ram(m_TxBuf,(far rom char*)str);
		uartPuts(m_TxBuf);
		m_TxBuf[0] =0;
		if (val != NON_VALUE){
			// make buffer
			IToAsc(m_TxBuf,val,5);
		}
		strcatpgm2ram(m_TxBuf,(far rom char *)"\n");
		uartPuts(m_TxBuf);
	}
}
